#==============================================================================#
#                        Copyright 2022-2024 ArchaicSoft                       #
#                                                                              #
# Boost Software License - Version 1.0 - August 17th, 2003                     #
#                                                                              #
# Permission is hereby granted, free of charge, to any person or organization  #
# obtaining a copy of the software and accompanying documentation covered by   #
# this license (the "Software") to use, reproduce, display, distribute,        #
# execute, and transmit the Software, and to prepare derivative works of the   #
# Software, and to permit third-parties to whom the Software is furnished to   #
# do so, all subject to the following:                                         #
#                                                                              #
# The copyright notices in the Software and this entire statement, including   #
# the above license grant, this restriction and the following disclaimer,      #
# must be included in all copies of the Software, in whole or in part, and     #
# all derivative works of the Software, unless such copies or derivative       #
# works are solely in the form of machine-executable object code generated by  #
# a source language processor.                                                 #
#                                                                              #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   #
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     #
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT    #
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE    #
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,  #
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER  #
# DEALINGS IN THE SOFTWARE.                                                    #
#==============================================================================#

@tool extends Control

var scn_buttons    : PackedScene = load("res://addons/asfw/_/sub_scenes/PluginButtons.tscn")

const URL_DOWNLOAD : String = "https://gitlab.com/ArchaicSoft/source-kits/asfw/-/archive/gdscript/asfw-gdscript.zip?path=addons/asfw/"
const URL_PROJECT  : String = "https://gitlab.com/api/v4/projects/41314714/repository/tree?ref=gdscript&path=addons/asfw"
const URL_PREFIX   : String = "https://gitlab.com/api/v4/projects/41314714/repository/files/addons%2Fasfw%2F"
const URL_SUFFIX   : String = "%2Fplugin.cfg/raw?ref=gdscript"

const ADDON_DIR    : String = "res://addons/asfw/%s/"

var _cur_addon     : String

func _ready() -> void:
	$Grid.show()

func _on_visibility_changed() -> void:
	if self.visible: _refresh_page()

func _refresh_page() -> void:
	# already refreshing
	if not $Grid.visible: return
	
	# hide the grid until done loading
	$Grid.hide()
	$Notifier.text = "Loading... Please wait."
	$Notifier.show()
	
	# remove existing listings
	var grid : GridContainer = $Grid
	for i in range(3, grid.get_child_count()):
		grid.get_child(i).queue_free()
	
	# initialize info dump
	var http_dir : HTTPRequest = $HTTP_Directories
	http_dir.cancel_request()
	http_dir.request(URL_PROJECT)
	await http_dir.request_completed
	
	# ensure the plugins templates exist
	_generate_asfw_templates()

func _generate_asfw_templates() -> void:
	# generate asfw templates from all plugins
	for plugin in DirAccess.get_directories_at("res://addons/asfw/"):
		var path : String = (ADDON_DIR % plugin) + "/templates/"
		if not DirAccess.dir_exists_absolute(path): continue
		_generate_script_templates(path)

func _generate_script_templates(template_src: String) -> void:
	# ensure node templates exists
	var template_dst : String = ProjectSettings.get_setting(
		"editor/script/templates_search_path") + "/"
	
	# create missing directory
	if not DirAccess.dir_exists_absolute(template_dst):
		DirAccess.make_dir_recursive_absolute(template_dst)
	
	# copy missing templates
	for dir in DirAccess.get_directories_at(template_src):
		var src_path : String = template_src + dir + "/"
		var dst_path : String = template_dst + dir + "/" 
		
		if not DirAccess.dir_exists_absolute(dst_path):
			DirAccess.make_dir_recursive_absolute(dst_path)
		
		for file in DirAccess.get_files_at(src_path):
			var src_file : String = src_path + file.get_file()
			var dst_file : String = dst_path + file.get_file().left(-1)
			
			if not FileAccess.file_exists(dst_file):
				DirAccess.copy_absolute(src_file, dst_file)

func _on_http_directories_request_completed(
	result: int,
	response_code: int,
	headers: PackedStringArray,
	body: PackedByteArray
) -> void:
	var response :             = JSON.parse_string(body.get_string_from_utf8())
	var http_cfg : HTTPRequest = $HTTP_PluginCFG
	
	# sift through the directories in the url addons folder
	for entry in response:
		# it is a directory type
		if entry.type == "tree":
			
			# cache the directory name
			_cur_addon = entry.name
			
			# get config information from sub-dir addons
			http_cfg.request(URL_PREFIX + _cur_addon + URL_SUFFIX)
			await http_cfg.request_completed
	
	# make our grid visible after finished loading 
	$Notifier.hide()
	$Grid.show()

func _on_http_plugincfg_request_completed(
	result: int,
	response_code: int,
	headers: PackedStringArray,
	body: PackedByteArray
) -> void:
	var response := body.get_string_from_utf8()
	
	# check for empty dir plugin requests (probably sub-dirs)
	if response == "{\"message\":\"404 File Not Found\"}": return
	
	# process the config data
	var config   := ConfigFile.new()
	config.parse(response)
	
	# generate the listing
	_create_listing(
		config.get_value("plugin", "name"),
		config.get_value("plugin", "description"),
		config.get_value("plugin", "version")
	)

func _create_listing(title: String, description: String, version: String) -> void:
	var grid       : GridContainer = $Grid
	var addon_name : String        = _cur_addon
	var addon_path : String        = ADDON_DIR % addon_name
	var patch_path : String        = "res://.godot/asfw_patch.zip"
	
	# generate the name
	var lbl_addon         := Label.new()
	lbl_addon.name         = addon_name
	lbl_addon.text         = title.substr(6, title.length() - 7)
	lbl_addon.mouse_filter = Control.MOUSE_FILTER_STOP
	lbl_addon.tooltip_text = description
	grid.add_child(lbl_addon)
	
	# generate the version
	var lbl_ver           := Label.new()
	lbl_ver.name           = addon_name + "_ver"
	lbl_ver.text           = version
	lbl_ver.horizontal_alignment = HORIZONTAL_ALIGNMENT_CENTER
	grid.add_child(lbl_ver)
	
	# toggle visible buttons
	var btns := scn_buttons.instantiate()
	
	# assign buttons to vars
	var http_req    : HTTPRequest = btns.get_child(0)
	var btn_update  : Button      = btns.get_child(1)
	var btn_install : Button      = btns.get_child(2)
	var btn_remove  : Button      = btns.get_child(3)
	
	# setup our http request object
	http_req.download_file = patch_path
	http_req.use_threads = true
	http_req.max_redirects = 2
	http_req.timeout = 1.0
	http_req.request_completed.connect(func(
		result: int,
		response_code: int,
		headers: PackedStringArray,
		body: PackedByteArray
	) -> void:
		var zip      := ZIPReader.new()
		zip.open(patch_path)
		
		var contents := zip.get_files()
		var git_len  := contents[0].length()
		for i in range(1, contents.size()):
			var real_path := "res://" + contents[i].substr(git_len)
			
			# process directory creation and move on
			if real_path.ends_with('/'):
				DirAccess.make_dir_recursive_absolute(real_path)
				continue
			
			# dump file contents
			var buffer := FileAccess.open(real_path, FileAccess.WRITE)
			buffer.store_buffer(zip.read_file(contents[i]))
			buffer.close()
		
		# close the zip file and end operation
		zip.close()
	)
	
	# install/update logic
	var fun_setup : Callable = func() -> void:
		# hide the grid until done loading
		$Grid.hide()
		$Notifier.text = "Downloading addon... Please wait."
		$Notifier.show()
		
		http_req.request(URL_DOWNLOAD + addon_name)
		
		await http_req.request_completed
		
		# notify the completion
		OS.alert("Package successfully installed!", "ASFW Addon Install")
		$Grid.show(); _refresh_page()
	
	btn_install.pressed.connect(fun_setup)
	btn_update.pressed.connect(fun_setup)
	btn_remove.pressed.connect(func() -> void:
		if DirAccess.dir_exists_absolute(addon_path):
			DirAccess.remove_absolute(addon_path)
	)
	
	# determine button visibility
	if not DirAccess.dir_exists_absolute(addon_path):
		# install button
		btn_install.disabled = false
		btn_install.show()
	else:
		# remove button
		if addon_name != "_": btn_remove.disabled = false
		
		# parse our current plugin's config/version
		var config   := ConfigFile.new()
		config.load(addon_path + "plugin.cfg")
		var cfg_ver  := config.get_value("plugin", "version")
		
		# check version is current
		if _version_id(cfg_ver) < _version_id(version):
			btn_update.disabled = false
		
		btn_update.show()
	
	grid.add_child(btns)

func _version_id(value: String) -> int:
	var id := value.split(".")
	return (id[0].to_int() << 32) | (id[1].to_int() << 16) | id[2].to_int()
